import 'package:hmg_patient_app_new/core/api/api_client.dart';
import 'package:hmg_patient_app_new/core/api_consts.dart';
import 'package:hmg_patient_app_new/core/exceptions/api_failure.dart';
import 'package:hmg_patient_app_new/core/common_models/generic_api_model.dart';
import 'package:dartz/dartz.dart';
import 'package:hmg_patient_app_new/features/prescriptions/models/resp_models/patient_prescriptions_response_model.dart';
import 'package:hmg_patient_app_new/features/prescriptions/models/resp_models/prescription_detail_response_model.dart';
import 'package:hmg_patient_app_new/services/logger_service.dart';

abstract class PrescriptionsRepo {
  Future<Either<Failure, GenericApiModel<List<PatientPrescriptionsResponseModel>>>> getPatientPrescriptionOrders({required String patientId});

  Future<Either<Failure, GenericApiModel<List<PrescriptionDetailResponseModel>>>> getPatientPrescriptionDetails({required PatientPrescriptionsResponseModel prescriptionsResponseModel});
}

class PrescriptionsRepoImp implements PrescriptionsRepo {
  final ApiClient apiClient;
  final LoggerService loggerService;

  PrescriptionsRepoImp({required this.loggerService, required this.apiClient});

  @override
  Future<Either<Failure, GenericApiModel<List<PatientPrescriptionsResponseModel>>>> getPatientPrescriptionOrders({required String patientId}) async {
    final mapDevice = {
      "isDentalAllowedBackend": false,
      "VersionID": 50.0,
      "Channel": 3,
      "LanguageID": 2,
      "IPAdress": "10.20.10.20",
      "generalid": "Cs2020@2016\$2958",
      "Latitude": 0.0,
      "Longitude": 0.0,
      "DeviceTypeID": 1,
      "PatientType": 1,
      "PatientTypeID": 1,
      "TokenID": "@dm!n",
      "PatientID": "1018977",
      "PatientOutSA": "0",
      "SessionID": "03478TYC02N80874CTYN04883475!?"
    };

    try {
      GenericApiModel<List<PatientPrescriptionsResponseModel>>? apiResponse;
      Failure? failure;
      await apiClient.post(
        PRESCRIPTIONS,
        body: mapDevice,
        onFailure: (error, statusCode, {messageStatus, failureType}) {
          failure = failureType;
        },
        onSuccess: (response, statusCode, {messageStatus, errorMessage}) {
          try {
            final list = response['PatientPrescriptionList'];
            if (list == null || list.isEmpty) {
              throw Exception("lab list is empty");
            }

            final prescriptionOrders = list.map((item) => PatientPrescriptionsResponseModel.fromJson(item as Map<String, dynamic>)).toList().cast<PatientPrescriptionsResponseModel>();

            apiResponse = GenericApiModel<List<PatientPrescriptionsResponseModel>>(
              messageStatus: messageStatus,
              statusCode: statusCode,
              errorMessage: null,
              data: prescriptionOrders,
            );
          } catch (e) {
            failure = DataParsingFailure(e.toString());
          }
        },
      );
      if (failure != null) return Left(failure!);
      if (apiResponse == null) return Left(ServerFailure("Unknown error"));
      return Right(apiResponse!);
    } catch (e) {
      return Left(UnknownFailure(e.toString()));
    }
  }

  @override
  Future<Either<Failure, GenericApiModel<List<PrescriptionDetailResponseModel>>>> getPatientPrescriptionDetails({required PatientPrescriptionsResponseModel prescriptionsResponseModel}) async {
    final mapDevice = {
      "AppointmentNo": prescriptionsResponseModel.appointmentNo.toString(),
      "SetupID": prescriptionsResponseModel.setupID,
      "EpisodeID": prescriptionsResponseModel.episodeID.toString(),
      "ClinicID": prescriptionsResponseModel.clinicID.toString(),
      "ProjectID": prescriptionsResponseModel.projectID.toString(),
      "DischargeNo": prescriptionsResponseModel.dischargeNo.toString(),
      "isDentalAllowedBackend": false,
      "VersionID": 50.0,
      "Channel": 3,
      "LanguageID": 2,
      "IPAdress": "10.20.10.20",
      "generalid": "Cs2020@2016\$2958",
      "Latitude": 0.0,
      "Longitude": 0.0,
      "DeviceTypeID": 1,
      "PatientType": 1,
      "PatientTypeID": 1,
      "TokenID": "@dm!n",
      "PatientID": "1018977",
      "PatientOutSA": "0",
      "SessionID": "03478TYC02N80874CTYN04883475!?"
    };

    try {
      GenericApiModel<List<PrescriptionDetailResponseModel>>? apiResponse;
      Failure? failure;
      await apiClient.post(
        prescriptionsResponseModel.isInOutPatient! ? GET_PRESCRIPTION_REPORT_ENH : GET_PRESCRIPTION_REPORT,
        body: mapDevice,
        onFailure: (error, statusCode, {messageStatus, failureType}) {
          failure = failureType;
        },
        onSuccess: (response, statusCode, {messageStatus, errorMessage}) {
          try {
            final list = prescriptionsResponseModel.isInOutPatient! ? response['ListPRM'] : response['INP_GetPrescriptionReport_List'];
            if (list == null || list.isEmpty) {
              throw Exception("prescription list is empty");
            }

            final prescriptionOrders = list.map((item) => PrescriptionDetailResponseModel.fromJson(item as Map<String, dynamic>)).toList().cast<PrescriptionDetailResponseModel>();

            apiResponse = GenericApiModel<List<PrescriptionDetailResponseModel>>(
              messageStatus: messageStatus,
              statusCode: statusCode,
              errorMessage: null,
              data: prescriptionOrders,
            );
          } catch (e) {
            failure = DataParsingFailure(e.toString());
          }
        },
      );
      if (failure != null) return Left(failure!);
      if (apiResponse == null) return Left(ServerFailure("Unknown error"));
      return Right(apiResponse!);
    } catch (e) {
      return Left(UnknownFailure(e.toString()));
    }
  }
}
